var sys = require('sys'),
    http = require('http'),
    querystring = require('querystring');
/**
 * 
 * @author Anton Podviaznikov(podviaznikov@gmail.com)
 */
var Janrain = function(apiKey)
{
    this.client = http.createClient(80, 'https://rpxnow.com');
    this.apiKey = apiKey;
    this.headers = {'Host': this.client.host};
    this.path = '/api/v2/auth_info';
};
Janrain.prototype.authenticate = function(token,callback,errorCallback)
{
    var path = this.path;
    if(token)
    {
        path = this.path+'?'+'apiKey='+this.apiKey+'&token='+token;
    }
    sys.log('Requested path='+path);
    var request = this.client.request('GET', path, this.headers);
    request.on('response', function (response) 
	{
	    sys.log('Response code='+response.statusCode);
	    if(response.statusCode==200)
        { 
            var buffer = '';
            response.setEncoding('utf8');response.on('data', function (chunk){buffer += (chunk || '');});
            response.on('end', function(){sys.log(buffer);callback(JSON.parse(buffer));});
        }
        else if(errorCallback)
        {
            errorCallback(response.statusCode);
        }
        else
        {
            sys.log('Failed to handle respeonse with code:'+response.statusCode);
        }
	});   
	request.end();
};
/**
 * Factory method for creating object instace that can send requests.
 */ 
exports.create = function(apiKey)
{
    return new Janrain(apiKey);
}
